Win32 GUI
window1
A miniml window application
[*BEGINPRO*]
[*BEGINDEF*]
[MakeDef]
Menu=1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0
1=
2=5,O,sol_asm2.exe $2 $5 /pe32 /info
3=
4=0,0,,5
5=
6=
7=0,0,\OllyDbg\OllyDbg,5
[MakeFiles]
0=window1.rap
1=window1.rc
2=window1.asm
3=window1.obj
4=window1.res
5=window1.exe
6=window1.def
7=window1.dll
8=window1.txt
9=window1.lib
10=window1.mak
11=window1.hla
[Resource]
[StringTable]
[Accel]
[VerInf]
[Group]
Group=Added files,Assembly,Resources,Misc,Modules
1=2
[*ENDDEF*]
[*BEGINTXT*]
window1.Asm
;------------------------------------------------------------------
; A minimal Win32 window application
;------------------------------------------------------------------

;------------------------------
; sections
;------------------------------
section "code" 		class_code
section "data"  	class_data
section "idata" 	class_imports

;------------------------------
; includes
;------------------------------
include \sol_asm\include\win32\kernel32.inc
include \sol_asm\include\win32\user32.inc
include \sol_asm\include\win32\gdi32.inc

;------------------------------
; program text
;------------------------------
.data
	module_handle	dd		0
	main_handle	dd		0

	my_class	WNDCLASS	?
	my_msg		MSG		?
	my_ps		PAINTSTRUCT	?

	wnd_title	db		"SOL_ASM Test Application",0
	class_name	db		"SOL_Window_Class",0
	msg_hello	db		"Hello World!",0

	msg_end		db		"end",0

.code

.entry Start

Start:
	invoke	GetModuleHandle,0
	mov	[module_handle],eax

	invoke	Win_Main

	invoke	ExitProcess,0
	ret


PROC Wnd_Proc1 stdcall
	USES	ebx,esi,edi
	ARG	wnd_handle, wnd_msg, wnd_wparam, wnd_lparam
	LOCAL	tmp_dc

	;---------------------------
	; Window callback procedure
	;---------------------------
	mov	eax,[wnd_msg]
	.IF eax == WM_DESTROY
		invoke	PostQuitMessage,0
		xor	eax,eax
	
	.ELSEIF eax == WM_PAINT
		invoke	BeginPaint,[wnd_handle], my_ps
		mov	[tmp_dc],eax
	
		invoke	TextOut,eax,32,32,msg_hello,12
	
		invoke	EndPaint,[wnd_handle], my_ps
		xor	eax,eax
	.ELSE
		;----------------------
		; default handling
		;----------------------
		invoke	DefWindowProc,[wnd_handle],[wnd_msg],[wnd_wparam],[wnd_lparam]		
	.ENDIF

	ret
ENDP


PROC Win_Main stdcall
	USES	esi

	;------------------------------------
	; This creates our window
	; and then it enters the message loop
	;------------------------------------

	;------------------------------------
	; fill-up and register the class
	;------------------------------------
	mov	esi,  my_class

	mov	[esi + WNDCLASS.style],CS_HREDRAW

	mov	[esi + WNDCLASS.wnd_proc_ptr],Wnd_Proc1

	mov	eax,[module_handle]
	mov	[esi + WNDCLASS.instance_handle],eax

	mov	[esi + WNDCLASS.class_name_ptr],class_name

	mov	[esi + WNDCLASS.back_brush_handle],COLOR_BTNFACE+2

	invoke	LoadCursor,0,IDC_ARROW
	mov	[esi + WNDCLASS.cursor_handle],eax

	invoke	LoadIcon,0,IDI_APPLICATION
	mov	[esi + WNDCLASS.icon_handle],eax

	invoke	RegisterClass,esi


	;-----------------------------
	; create the window
	;-----------------------------
	mov	eax,WS_OVERLAPPED+WS_CAPTION+WS_SYSMENU+WS_THICKFRAME+WS_MINIMIZEBOX+WS_MAXIMIZEBOX

	invoke	CreateWindowEx,0,class_name,wnd_title,eax,32,64,320,240,0,0,[module_handle],0
	mov	[main_handle],eax

	invoke	ShowWindow,eax,SW_SHOW
	invoke	UpdateWindow,[main_handle]

	;----------------------------
	; message loop
	;----------------------------
msg_loop:
	invoke	GetMessage,my_msg,0,0,0
	test	eax,eax
	jz	finish

	cmp	eax,0ffff_ffffh
	jz	finish

	invoke	TranslateMessage,my_msg
	invoke	DispatchMessage,my_msg			

	jmp	msg_loop


finish:
	ret
ENDP
[*ENDTXT*]
[*ENDPRO*]
